/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2009 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

#ifndef CONFIGURATION_MANAGER_H
#define CONFIGURATION_MANAGER_H

#include <string>
#include <iostream>

#include "toppers/oil/oil_parser.hpp"
#include "toppers/text.hpp"
#include "toppers/diagnostics.hpp"

using namespace toppers::oil;

namespace toppers
{
	namespace configuration_manager
	{

		class config_manage
		{
			public:
				config_manage(void)
				{
				}
				~config_manage()
				{
					delete description_str;
					delete parser;
				}
				bool read_configuration
					(toppers::text *txt , std::vector<std::string> const& objlist);
				void dump_configuration(void)
				{
					parser->dump_implementation();
					parser->dump_definition();
				}

				::oil_def* const get_obj_def(void)
				{
					return oil_def;
				}
				bool validate_and_assign_default_configuration(void);
			private:
				bool validate_object_reference
						(std::string obj_name , std::vector<object_ref> *obj_refs);
				toppers::text *description;
				string *description_str;
				oil_parser *parser;
				::oil_def *oil_def;
				::oil_impl *oil_impl;
		};

	}	/* namespace configuration_manager */

}	/* namespace toppers */

#endif	/* CONFIGURATION_MANAGER_H */
